
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>python学习笔记：什么事*args和**kwargs？ / 憋错料</title>

    <meta name="description" content="python学习笔记：什么事*args和**kwargs？ 一.*args和**kwargs原理 先看个例子: def test(*args,**kwargs): print(&quot;args =&quot;,args) print(&quot;kwargs =&quot;,kwargs) print(&quot;----------------------------------&quot;) if __name__ == '__main__': test(1,5,94,564) test(a=1,b=2,c=3) test(1,2,3,4,a=1 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">python学习笔记：什么事*args和**kwargs？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一.*args和**kwargs原理</strong></p>
<p>　先看个例子：</p>
<pre>def test(*args,**kwargs):
    print("args =",args)
    print("kwargs =",kwargs)
    print("----------------------------------")
if __name__ == ‘__main__‘:
    test(1,5,94,564)
    test(a=1,b=2,c=3)
    test(1,2,3,4,a=1,b=2,c=3)
    test(‘I love python‘,1,None,a=1,b=2,c=3)
#输出：
args = (1, 5, 94, 564)
kwargs = {}
----------------------------------
args = ()
kwargs = {‘a‘: 1, ‘b‘: 2, ‘c‘: 3}
----------------------------------
args = (1, 2, 3, 4)
kwargs = {‘a‘: 1, ‘b‘: 2, ‘c‘: 3}
----------------------------------
args = (‘I love python‘, 1, None)
kwargs = {‘a‘: 1, ‘b‘: 2, ‘c‘: 3}
----------------------------------</pre>
<p>可以看到这两个是python中的可变参数，*args表示任何多个无名参数，他是个tuple，**kwargs表示关键字参数，它是个dict。在同时使用*args和**kwargs时，必须*args参数列要在**kwargs前面，要是test(a=1,b=2,c=3,1,2,3,4)这样调用的话肯定会报语法错误的！</p>
<p><strong>二.使用**kwargs创建字典：</strong></p>
<pre>def kw_dict(**kwargs):
    return kwargs
print(kw_dict(k1=‘v1‘,k2=‘v2‘,k3=‘v3‘))
#执行结果：
{‘k3‘: ‘v3‘, ‘k2‘: ‘v2‘, ‘k1‘: ‘v1‘}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:57:19 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/logs/" title="logs">logs</a>, <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/span/" title="span">span</a>, <a href="https://www.biecuoliao.com/tag/%e5%8e%9f%e7%90%86/" title="原理">原理</a>, <a href="https://www.biecuoliao.com/tag/%e9%94%99%e8%af%af/" title="错误">错误</a>, <a href="https://www.biecuoliao.com/tag/%e8%be%93%e5%87%ba/" title="输出">输出</a>, <a href="https://www.biecuoliao.com/tag/%e4%be%8b%e5%ad%90/" title="例子">例子</a>, <a href="https://www.biecuoliao.com/tag/python%e5%ad%a6%e4%b9%a0/" title="python学习">python学习</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>python学习笔记：什么事*args和**kwargs？的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02kAn23.html" rel="bookmark">python学习笔记7-函数的多类型传值和冗余参数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python学习笔记7-函数的多类型传值和冗余参数 函数多类型传值 例一,元组传参 In [2]: def fun(x,y):    ...:     return x+y In [4]: print fun(3,5) 8 In [5]: t=(1,2) In [6]: print fun(*t)  注意,这里使用的是*t调用元组t 3 In [7]: print fun(t)   用t,不加*,报错只给了一个参数,需要给2哥参数 --------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBYOQq4.html" rel="bookmark">Python 学习笔记 6</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.1 字典 字典就是一个关联数组(或者称为哈希表).它是通过关键字索引的对象的集合.使用大括号{}来创建一个字典. print &quot;字典&quot; dic={ &quot;username&quot;:&quot;beazley&quot;, &quot;home&quot;:&quot;/home/beazley&quot;, &quot;uid&quot;:500 } print dic uu=dic[&quot;username&quot;] dd=dic[&quot;home&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZDGYgM.html" rel="bookmark">python学习笔记之函数总结--高阶函数以及装饰器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python学习笔记之函数总结--高阶函数以及装饰器 Python特点: 1.不是纯函数式编程(允许变量存在): 2.支持高阶函数(可以传入函数作为变量): 3.支持闭包(可以返回函数): 4.有限度的支持匿名函数: 高阶函数: 1.变量可以指向函数: 2.函数的参数可以接收变量: 3.一个函数可以接收另一个函数作为参数: 下面我将示例一些函数的写法以及使用,并说明python中函数的特性: 1.基本的高阶函数示例: #!/usr/bin/env python def func():      			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wPRKV4.html" rel="bookmark">Python学习笔记（一）&mdash;&mdash;基本知识点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要记录学习Python的历程和用于复习.查阅之用. 知识点: 数据类型(列表.元组.字典.集合) 帮助文档 函数(默认参数.可变参数.关键字参数.参数组合) 数据类型: 列表:list       有序集合,可增删元素 ,使用[]表示.可变. 元组:tuple    与list类似,但是一初始化就不能修改.使用()表示.不可变. 字典:dict      使用key-value存储,查找速度极快,但占用大量内存.使用{}表示. 集合:set       一组key的集合,但不存储value.使			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41V2jkM.html" rel="bookmark">python &amp;nbsp&semi;  学习笔记 &lpar;核心&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python    学习笔记 (核心) Python解释器从头到尾一行接一行执行脚本 # -*- coding: UTF-8 -*-    //字符编码 不区分单引号和双引号,x='hello',x[0],x[-1]指最后一个字符,x[2:4]取子串, '''hello''' #hello三引号会保留文本输入时的换行符制表符等不需要转义,用于多行原样输入保存 'hello'+'world' #字符串拼接,'hello'*2 #字符串重复 help(fun) #帮助,help(module.met			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O87qo4.html" rel="bookmark">廖Python学习笔记一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 廖Python学习笔记 大的分类 如函数 用二级标题,下面的用三级 如输入输出 1.1.1. 输入输出 1.1.1.1. 输出 用 print() 在括号里加上字符串,就可以向屏幕上输出指定的文字print()函数可以接受多个字符串,用逗号(,)隔开,依次输出遇到逗号输出一个空格.如图 1.1.1.2. 输入 提供了一个input(),可以让用户输入字符串,并存放到一个变量里. name = input() print(name) 1.1.2. 变量 是初中数学所学的代数基础知识的使用.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vAkX0.html" rel="bookmark">OpenCV之Python学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OpenCV之Python学习笔记 直都在用Python+OpenCV做一些算法的原型.本来想留下发布一些文章的,可是整理一下就有点无奈了,都是写零散不成系统的小片段.现在看 到一本国外的新书&lt;OpenCV Computer Vision with Python&gt;,于是就看一遍,顺便把自己掌握的东西整合一下,写成学习笔记了.更需要的朋友参考. 阅读须知: 本文不是纯粹的译文,只是比较贴近原文的笔记:         请设法购买到出版社出版的书,支持正版. 从书名就能看出来本书是介绍在Pytho			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/N4pjyy0.html" rel="bookmark">python学习笔记12-模块使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python学习笔记12-模块使用 模块os,sys 什么是模块? 模块os,sys 模块是Python组织代码的一种基本方式 一个Python脚本可以单独运行,也可以导入到另外一个脚本运行,用import hello语句来导入,不用加入.py 什么是Python的 包? Python的模块可以按照目录组织为包 创建一个包的步骤: 创建一个名字为包名的目录 在改目录下创建一个__init__.py文件 根据需要,在该目录下存放脚本文件或已编译的扩展及子包 import pack.m1,pack.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/L3rRN73.html" rel="bookmark">python学习笔记2&mdash;python文件类型、变量、数值、字符串、元组、列表、字典</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python学习笔记2--python文件类型.变量.数值.字符串.元组.列表.字典 一.Python文件类型 1.源代码 python源代码文件以.py为扩展名,由pyton程序解释,不需要编译 [[email protected] day01]# vim 1.py #!/usr/bin/python        print 'hello world!' [[email protected] day01]# python 1.py hello world! 2.字节代码 Python源码文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vEXaj0.html" rel="bookmark">Python学习笔记--未经排版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python 学习笔记 Python中如何做到Print() 不换行 答:Print(&quot;输出内容&quot;,end='不换行的分隔内容'),其中end=后面为2个单引号 注:在Python 2.x中,Print &quot;输出内容&quot;, 即在输出内容后加一逗号 Python中 is 和 == 的区别 答:Python中的对象包含三要素:id.type.value 其中id用来唯一标识一个对象,type标识对象的类型,value是对象的值 is判断的是a对象是否就是b对象,是通过id来			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmOLp3.html" rel="bookmark" class="title">枯燥的数据库&OpenCurlyDoubleQuote;三级模式&rdquo;</a>
					<div>
						以下这些概念比较枯枯燥,若学好数据库,还是了解下基础的东西,在实际中感觉好象没有应到,但是系统化的学习还是有了解的必要. ANSI将数据库结构分为3级:面向用户或应用程序员的用户级.面向建立和维护数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rGEb4.html" rel="bookmark" class="title">全屏游戏中自动切出到桌面的问题解决</a>
					<div>
						近期遇到一个客户全屏游戏中,自动切出游戏到桌面的问题,于是到现场解决.     打开游戏&lt;英雄联盟&gt;测试,并开启前端进程监测软件监测.一段时间过后,游戏切出,发现一个名称为&quot;De ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41Q7o4.html" rel="bookmark" class="title">数据结构 树的创建（线索化二叉树）</a>
					<div>
						//二叉树的线索化 #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; #include&lt;string.h&gt; //定义二叉树线索化节点 typ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pv9x80.html" rel="bookmark" class="title">Java8新增的Lambda表达式</a>
					<div>
						Lambda表达式支持将代码块作为方法参数,Lambda表达式允许使用更简单的代码来创建只有一个抽象方法的接口(这种接口被称为函数式接口)的实例. 5.8.1 Lambda 表达式入门 Command ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaJv84.html" rel="bookmark" class="title">让你提前认识软件开发&lpar;40&rpar;：既要写好代码，又要写好文档</a>
					<div>
						第3部分 软件研发工作总结 既要写好代码,又要写好文档 对于软件相关行业,在学校或单位上,大家也许都已经注意到了,除了要编写的程序.绘制设计图之外,还有一个重要的工作便是写文档.为什么要写文档呢?因为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdxo8M.html" rel="bookmark" class="title">无NavigationBar到有NavigationBar视图切换时的一个坑</a>
					<div>
						NavigationController在iOS App中是最常见不过了,可以说是每个App中必备的了.自iOS7开始,系统自带的右滑返回效果,也可以让有NavigationBar的视图切换很丝 滑流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomRVb3.html" rel="bookmark" class="title">Android简单加密保护自有图片资源</a>
					<div>
						现在大部分android应用的图片资源,被反编译后就可以直接拿来用,如果不想让自己的图片资源直接被反编译后使用,首先想到的应该是把图片加密.这里笔者抛砖引玉,草草写了一个对图片进行简单加密的方法,希望 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXojo4.html" rel="bookmark" class="title">【个人测试公众号】微信公众号接入过程问题笔记</a>
					<div>
						网站备案审核实在太慢了. 然后就用了以前申请的sina sae空间+域名 配置了微信公众号个人测试沙箱 第一步 :先进入微信测试公众号页面 然后是手机微信扫码授权后,就有如下界面 第二步 :配置接口信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyOL50.html" rel="bookmark" class="title">springmvc文件下载之文件名下划线问题终极解决方案</a>
					<div>
						直接上代码:Action中代码片段. @RequestMapping(&quot;download&quot;)public String download(ModelMap model, @Mode ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzABw0.html" rel="bookmark" class="title">Net程序命名规则</a>
					<div>
						表名 Tb_SysUser 页面存放位置及规则 Sysmanage SysUserList.aspx SysUserEdit.aspx SysUserDetail.aspx Model 类 SysUs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPw2yy4.html" rel="bookmark" class="title">HDU OJ  迷障  题目257</a>
					<div>
						﻿﻿ /* 迷瘴 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDy9Ko0.html" rel="bookmark" class="title">Qt多线程编程总结（一）（所有GUI对象都是线程不安全的）</a>
					<div>
						Qt对线程提供了支持,基本形式有独立于平台的线程类.线程安全方式的事件传递和一个全局Qt库互斥量允许你可以从不同的线程调用Qt方法. 这个文档是提供给那些对多线程编程有丰富的知识和经验的听众的.推荐阅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkngoM.html" rel="bookmark" class="title">c&num; winform 窗体载入时位置跳动</a>
					<div>
						//this.MaximizeBox = false; ;      //this.MinimizeBox = false; ;      //this.MaximumSize = new Size( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022PAE0.html" rel="bookmark" class="title">android 自己定义开关（SwitchButton）</a>
					<div>
						近期心血来潮,写了一个自己定义仿iPhone的开关. 有须要的同学能够来下载啦.支持点击自己主动滚动,速率能够自己依据须要改动.触摸滚动,大小自己定义,支持改动样式.就不录制动画,就上传了两张图给大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzE6624.html" rel="bookmark" class="title">UVALive 6451&colon;Tables&lpar;模拟 Grade D&rpar;</a>
					<div>
						VJ题目链接 题意:模拟输出表格 思路:模拟……很暴力 代码: #include &lt;cstdio&gt; #include &lt;cstring&gt; #include &lt;cstdli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvomYM.html" rel="bookmark" class="title">相片批量压缩和改名小工具</a>
					<div>
						您是否有过从相机中取出的照片保存起来太占空间.上传太费力的经历呢? 这个小工具由此而生,特点如下: 1.本软件提供多种图片的压缩功能.目前支持图片格式有:BMP JPG GIF PNG. 2.文件列表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRRde3.html" rel="bookmark" class="title">vs加js引用</a>
					<div>
						今天又有一个同事问我“在VS中如何让一个JS文件智能提示另一个JS文件中的成员”,他说Google了一下,并没有找到答案,然后我把这个小技巧贴出来,希望能被Google到. 有时候会有这种情况:当我的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBW8KK0.html" rel="bookmark" class="title">&period;NET基础2</a>
					<div>
						这一篇我们来讲解C#中的运算符 1. C#中的算术运算符 5个算数运算符:+  -  *  /  %     它们都是二元运算符,*  /  % 的运算优先级相同,并且高于 +  - ,+  - 的运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wpEej4.html" rel="bookmark" class="title">sublime text 2 c&plus;&plus;编译 环境 问题小结</a>
					<div>
						闲来无事,想要用subllime text 2 写下c++小程序,以前没用过这个编译c++, 期间出过很多问题,但是安装了sublime text 3 直接可以使用,前提安装了gcc/g++ 编译,没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J2vbQ4.html" rel="bookmark" class="title">linux生成随机密码</a>
					<div>
						通常情况下大家生成密码都好困惑,一来复杂程度不够会不安全,复杂程度够了又不能手动随便敲击键盘打出一同字符(但通常情况下这些字符是有规律的), 使用1password 或者 keepass 这种软件生成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
